// pages/home/home.js
const Cache = require('../../utils/cache.js');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    userInfo: {
      avatarUrl: '',
      nickName: '',
    },
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {

  },

  onReady() {

  },
  onShow() {
    this.setNavigationBarColor();
    this.getStorageSize();
  },
  setNavigationBarColor() {
    const themeColor = Cache.get('themeColor') || '#406Eff';
    this.hexToRgb(themeColor);
    const textColor = Cache.get('textColor') || '#ffffff';
    const userInfo = Cache.get('userInfo')||'';
    this.setData({
      themeColor,
      textColor,
      userInfo
    })
    wx.setNavigationBarColor({
      frontColor: textColor,
      backgroundColor: themeColor,
      animation: {
        duration: 400,
        timingFunc: 'easeIn'
      }
    })
  },
  hexToRgb(hex) {
    console.log(hex)
    hex = hex.replace(/^#/, '');
    var bigint = parseInt(hex, 16);
    var r = (bigint >> 16) & 255;
    var g = (bigint >> 8) & 255;
    var b = bigint & 255;
    this.setData({
      boxshadow: `RGB(${r}, ${g}, ${b},0.2)`
    });
  },
  navToTheme(){
    wx.navigateTo({
      url: '/pages/theme/theme',
    })
  },
  navToUserInfo(){
    wx.navigateTo({
      url: '/pages/user-info/user-info',
    })
  },
  navToAbout(){
    wx.navigateTo({
      url: '/pages/about/about',
    })
  },
  ClearStorage() {
    wx.showActionSheet({
      itemList: ["清除设置"],
      success(t) {
        wx.showLoading({
          title: "清除中"
        }), Cache.clear(), wx.hideLoading(), wx.showToast({
          title: "清除成功",
          icon: "success",
          duration: 2e3
        }), setTimeout(function () {
          wx.reLaunch({
            url: "/pages/index/index"
          });
        }, 2e3);
      }
    });
  },
  getStorageSize() {
    var that = this
    wx.getStorageInfo({
      success(res) {
        that.setData({
          storageSize: res.currentSize
        })
      }
    })
  },
  clear() {
    wx.showActionSheet({
      itemList: ["清理缓存"],
      success(t) {
        wx.showLoading({
          title: "清理中"
        }), wx.clearStorage(), wx.hideLoading(), wx.showToast({
          title: "清理成功",
          icon: "success",
          duration: 2e3
        }), setTimeout(function () {
          wx.reLaunch({
            url: "/pages/index/index"
          });
        }, 2e3);
      }
    });
  },
  onHide() {

  },
  onUnload() {

  },
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },
  onShareAppMessage() {

  }
})