function _get({url , data}) {
    wx.showLoading({ title: "加载中", mask: true, });
    return new Promise((resolve , reject)=> {
        wx.request({
            url,
            data,
            header: {'content-type':'application/json'},
            method: 'GET',
            dataType: 'json',
            responseType: 'text',
            success: (res)=>{
                res.statusCode === 200 ? resolve(res.data):reject(res.data);
            },
            fail: (err)=>{
                reject(err);
            },
            complete: ()=>{
                wx.hideLoading();
            }
        });
    })
}
function _post({url , data}) {
    wx.showLoading({ title: "加载中", mask: true, });
    return new Promise((resolve , reject)=> {
        wx.request({
            url: url,
            data: data,
            header: {'content-type':'application/x-www-form-urlencoded'},
            method: 'POST',
            dataType: 'json',
            responseType: 'text',
            success: (res)=>{
                res.statusCode === 200 ? resolve(res.data) : reject(res.data);
            },
            fail: (err)=>{
                reject(err);
            },
            complete: ()=>{
                wx.hideLoading();
            }
        });
    })
}
export default  {
    _get , 
    _post
}